<?php

namespace Ems\Logic\ProcessamentoSolicitacao;

use Ems\Util\{ Utils, ExpectedException };
use Ems\Services\OcorrenciaService;
use Util\{ DateUtil, NovoCodigo, Repositories };

class ProcessamentoSolicitacaoTreinamento extends ProcessamentoSolicitacao {

    public const IDTREINAMENTOINT_DEFAULT = 'N';
    
    public function efetivar() {
        $itens = $this->getItensAssociativeArray();
        
        $nrvinculom       = $this->getSolicitacao()->getNrvinculom();
        $nrorg            = Utils::getParamters()->getNrorg();
        $dsobssolicitacao = $this->getSolicitacao()->getDsobssolicitacao();
        $observacao       = $this->getObservacaoComProtocolo($dsobssolicitacao);

        $dataAprovacaoHE = !empty($itens['DTAPROVAHE']) ?
            DateUtil::getDataDeString(substr($itens['DTAPROVAHE'],0,10), DateUtil::FORMATO_DATA, true) : null;
        $nrCurso = $itens['NRCURSO'] ?? null;
        $nrPerfacesAprov = $itens['NRPERFACESAPROV'] ?? null;
        $nrMetodoTre = $itens['NRMETODOTRE'] ?? null;
        $nmTreinamento = $itens['NMTREINAMENTO'] ?? null;
        $nrPerfAcesExec = $itens['NRPERFACESEXEC'] ?? null;
        $idTreinamentoInt = $itens['IDTREINAMENTOINT'] ?? self::IDTREINAMENTOINT_DEFAULT;
        $dtIniplanejadoTre = !empty($itens['DTINIPLANEJADOTRE']) ?
            DateUtil::getDataDeString(substr($itens['DTINIPLANEJADOTRE'],0,10), DateUtil::FORMATO_DATA, true) : null;
        $dtFimplanejadoTre = !empty($itens['DTFIMPLANEJADOTRE']) ?
            DateUtil::getDataDeString(substr($itens['DTFIMPLANEJADOTRE'],0,10), DateUtil::FORMATO_DATA, true) : null;
        
        $result = Utils::getEntityManager()->getRepository(Repositories::GPE_VINCULOM)->findOneBy(array("nrorg"=> $nrorg,"nrvinculom" => $nrvinculom));
        $result = Utils::getEntityManager()->getRepository(Repositories::GPE_PESSOA)->findOneBy(array("nrorg"=> $nrorg,"nrpessoa" => $result->getNrpessoa()));
        
        $gpeTreinamento = Repositories::GPE_TREINAMENTO;
        $treinamento = new $gpeTreinamento;
        
        $treinamento->setNrparcnegaprov($result->getNrparcnegocio());
        $treinamento->setCdoperinclusao(Utils::getParamters()->getCdoperador());
        $treinamento->setDtfimplanejadotre($dtFimplanejadoTre);
        $treinamento->setDtinclusao(DateUtil::getDataAtual());
        $treinamento->setDtiniplanejadotre($dtIniplanejadoTre);

        $treinamento->setIdeficaciatreinamento('N');
        $treinamento->setIdstatustreinamento('PENDENTE');
        $treinamento->setIdtreinamentoint($idTreinamentoInt);
        
        $treinamento->setNmtreinamento($nmTreinamento);
        $treinamento->setNrcurso($nrCurso);
        $treinamento->setNrmetodotre($nrMetodoTre);
        $treinamento->setNrorg($nrorg);
        $treinamento->setNrorginclusao($nrorg);

        $treinamento->setNrperfacesaprov($nrPerfacesAprov);
        $treinamento->setNrperfacesexec($nrPerfAcesExec);
        $treinamento->setDsobstreinamento($observacao);

        $treinamento->setNrtreinamento(NovoCodigo::geraCodigo($nrorg, 'GPE_TREINAMENTO', 1, 12, true));
        Utils::getEntityManager()->persist($treinamento);
        Utils::getEntityManager()->flush();
    }
    
    public function rejeitar() {}
}