<?php
namespace HCM\FPA\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;
use HCM\Util\Repositories;
use HCM\Util\HCMParameters;

class RegraRepository {
    protected  $connection;
    public function __construct(Connection $connection, EntityManager $entityManager) {
        $this->connection = $connection;
        $this->entityManager = $entityManager;
    }
    
    public function getRegrasEvento($params){
        $sql = <<<SQL
SELECT TM.DTINIVIGENCIA, TM.CDOPERULTATU, TM.DTFIMVIGENCIA, TM.IDDEBUG, TM.NRORG, TH.NRREGRAH, TH.NMREGRAH, TH.NRREGRAM, TH.NREVENTOM, TH.DTMESCOMPETENC, TH.DSREGRA, TH.DSOBSERVACAO, TH.DTINCLUSAO, TH.DTULTATU, TH.NRORGINCLUSAO, TH.CDOPERINCLUSAO, TH.NRORGULTATU, EVH.NMEVENTOH FROM FPA_REGRAM TM INNER JOIN FPA_REGRAH TH ON TM.NRREGRAM = TH.NRREGRAM AND TH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM FPA_REGRAH H1 WHERE H1.NRREGRAM = TH.NRREGRAM AND H1.DTMESCOMPETENC <=:P_DTMESCOMPETENC ) LEFT JOIN FPA_EVENTOH EVH ON TH.NREVENTOM = EVH.NREVENTOM AND EVH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM FPA_EVENTOH H1 WHERE H1.NREVENTOM = EVH.NREVENTOM AND H1.DTMESCOMPETENC <=:P_DTMESCOMPETENC ) WHERE ( TM.NRORG =:P_NRORG OR TM.NRORG =:P_NRORG_PADRAO ) AND (TH.NREVENTOM = :P_NREVENTOM OR :P_NREVENTOM IS NULL)
SQL;
        // $params = array(
        //     'P_NRORG'           => $nrorg,
        //     'P_NRORG_PADRAO'    => $nrorgpadrao,
        //     'P_NREVENTOM'       => intval($nreventom),
        //     'P_DTMESCOMPETENC'  => $dtcompetencia->format('d/m/Y')
        // );
        
        // $params['P_DTMESCOMPETENC'] = $params['P_DTMESCOMPETENC']->format('d/m/Y');
        // $params['P_NREVENTOM'] = intval($params['P_NREVENTOM']);
        
        return $this->connection->fetchAll($sql, $params);
    }
}