/******************************************************************************/
/* Sistemas Integrados TECNISA                                                */
/*                                                                            */
/* Compras e Suprimentos                                                      */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/* Nome: LIMPADADOSCOC                                                            */
/*                                                                            */
/* Descrio:                                                                 */
/* Limpa os Dados dos Preos dos Produtos e seus respectivos logs             */
/*                                                                            */
/*                                                                            */
/* Criao:                                                                   */
/* 27/04/2001 - Alessandra Rosa Rezende                                       */
/******************************************************************************/
/* PARAMETROS:                                                                */
/******************************************************************************/

CREATE OR REPLACE PROCEDURE LIMPADADOSCOC
  (P_CDFILLISTA  IN VARCHAR2,
   P_TCDFILIAL   IN VARCHAR2,
   P_IDLIMPPRECO IN VARCHAR2,
   P_IDLIMPHIST  IN VARCHAR2,
   P_DTLIMPPRECO IN DATE DEFAULT NULL,   /* LIMPA O PREO DO PRODUTO E DO HISTRICO DE ALTERAO*/
   P_NMOPERADOR  IN OPERADOR.NMOPERADOR%TYPE,
   P_DSSISTEMA   IN VARCHAR2,
   P_DSLIMPEZA   IN VARCHAR2,
   P_DSLIMPEZA1  IN VARCHAR2,
   P_IDLIMPOU   OUT VARCHAR2) AS

   V_IDLIMPOU      VARCHAR2(1);

BEGIN

 V_IDLIMPOU := '0';

 IF (P_IDLIMPPRECO = 'S') AND (P_IDLIMPHIST = 'N') THEN

    DELETE PRODUTOAP
    WHERE
      ((INSTR(P_CDFILLISTA, CDFILIAL) <> 0) OR P_TCDFILIAL = 'T') AND
      DTCUSTOAP <= P_DTLIMPPRECO;

    IF SQL%ROWCOUNT <> 0 THEN

       INSERT INTO LOGLIMPEZA
          (DTLIMPDADOS, DSSISTLIMPEZ, NMOPERLIMPEZ,
           DTFINALIMPEZ, DSLIMPEZA)
       VALUES
          (SYSDATE, P_DSSISTEMA, P_NMOPERADOR,
           P_DTLIMPPRECO, P_DSLIMPEZA);
       V_IDLIMPOU := '1';
    END IF;
 END IF;

 IF (P_IDLIMPHIST = 'S') THEN

    DELETE PRODUTOAP
    WHERE
      ((INSTR(P_CDFILLISTA, CDFILIAL) <> 0) OR P_TCDFILIAL = 'T') AND
      DTCUSTOAP <= P_DTLIMPPRECO;

    DELETE LOGPRODUTOAP
    WHERE
      ((INSTR(P_CDFILLISTA, CDFILIAL1) <> 0) OR P_TCDFILIAL = 'T') AND
      DTCUSTOAP1 <= P_DTLIMPPRECO;

    IF SQL%ROWCOUNT <> 0 THEN

       INSERT INTO LOGLIMPEZA
          (DTLIMPDADOS, DSSISTLIMPEZ, NMOPERLIMPEZ,
           DTFINALIMPEZ, DSLIMPEZA)
       VALUES
          (SYSDATE, P_DSSISTEMA, P_NMOPERADOR,
           P_DTLIMPPRECO, P_DSLIMPEZA1);
       V_IDLIMPOU := '2';
    END IF;
 END IF;

 P_IDLIMPOU := V_IDLIMPOU;
END;
/
